﻿using CitizenFX.Core;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace LuaCSTest.Client
{
    public class HelloWorld : BaseScript
    {
		public delegate string dSayHelloWorld(int i);

        private int number1 = 1;

		public int Number1
		{
			get { 
				return number1 - 1; 
			}
			set {
				Console.WriteLine($"I was {number1}, now I am {value}");
				number1 = value; 
			}
		}

		private string Name;

		public string myName
		{
			get { return Name; }
			private set { Name = value; }
		}

		private int instanceID = -1;

        public int ID
        {
            get { return instanceID; }
            private set { instanceID = value; }
        }


        public HelloWorld(string name, int ID)
		{
			Name = name;
			instanceID = ID;
			dSayHelloWorld dshw = new dSayHelloWorld(SayHelloWorld);

			Exports.Add($"HelloWorld_i{ID}", dshw);
		}

		public int Number2 = 2;

		public string SayHelloWorld(int i)
		{
			return "Hello, world!";
		}

		internal string SayHelloWorld2(string s)
		{
			return "Hello, world! #2";
		}

		private string SayHelloWorld3(bool b)
		{
			return "Hello, World! #3";
		}

	}
}
